# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

## browser/locales/en-US/browser/menubar.ftl

## File menu

file-menu =
    .label = File
    .accesskey = F
tab-cmd =
    .label = New Tab
    .accesskey = T
new-user-context =
    .label = New Container Tab
    .accesskey = B
new-navigator-cmd =
    .label = New Window
    .accesskey = N
new-private-window =
    .label = New Private Window
    .accesskey = W

# Only displayed on OS X, and only on windows that aren't main browser windows,
# or when there are no windows but Firefox is still running.
open-location-cmd =
    .label = Open Location…
open-file-cmd =
    .label = Open File…
    .accesskey = O
close-cmd =
    .label = Close
    .accesskey = C
close-window =
    .label = Close Window
    .accesskey = d
save-page-cmd =
    .label = Save Page As…
    .accesskey = A
email-page-cmd =
    .label = Email Link…
    .accesskey = E
print-setup-cmd =
    .label = Page Setup…
    .accesskey = u
print-preview-cmd =
    .label = Print Preview
    .accesskey = v
print-cmd =
    .label = Print…
    .accesskey = P
go-offline-cmd =
    .label = Work Offline
    .accesskey = k
quit-application-cmd =
    .label = Quit
    .accesskey = Q

## Edit menu

edit-menu =
    .label = Edit
    .accesskey = E
undo-cmd =
    .label = Undo
    .accesskey = U
redo-cmd =
    .label = Redo
    .accesskey = R
cut-cmd =
    .label = Cut
    .accesskey = t
copy-cmd =
    .label = Copy
    .accesskey = C
paste-cmd =
    .label = Paste
    .accesskey = P
delete-cmd =
    .label = Delete
    .accesskey = D
select-all-cmd =
    .label = Select All
    .accesskey = A
find-on-cmd =
    .label = Find in This Page…
    .accesskey = F
find-again-cmd =
    .label = Find Again
    .accesskey = g
bidi-switch-text-direction-item =
    .label = Switch Text Direction
    .accesskey = w
preferences-cmd-unix =
    .label = Preferences
    .accesskey = n

## View menu

view-menu =
    .label = View
    .accesskey = V
view-toolbars-menu =
    .label = Toolbars
    .accesskey = T
view-customize-toolbar =
    .label = Customize…
    .accesskey = C
view-sidebar-menu =
    .label = Sidebar
    .accesskey = e
bookmarks-button =
    .label = Bookmarks
history-button =
    .label = History
synced-tabs =
    .label = Synced Tabs
full-zoom =
    .label = Zoom
    .accesskey = Z
full-zoom-enlarge-cmd =
    .label = Zoom In
    .accesskey = I
full-zoom-reduce-cmd =
    .label = Zoom Out
    .accesskey = O
full-zoom-reset-cmd =
    .label = Reset
    .accesskey = R
full-zoom-toggle-cmd =
    .label = Zoom Text Only
    .accesskey = T
page-style-menu =
    .label = Page Style
    .accesskey = y
page-style-no-style =
    .label = No Style
    .accesskey = n
page-style-persistent-only =
    .label = Basic Page Style
    .accesskey = b
charset-menu2 =
    .label = Text Encoding
    .accesskey = c

## Full Screen controls
## Match what Safari and other Apple applications use on OS X Lion.
#
enter-full-screen-cmd =
    .accesskey = F
    .label = Enter Full Screen
exit-full-screen-cmd =
    .accesskey = F
    .label = Exit Full Screen
full-screen-cmd =
    .accesskey = F
    .label = Full Screen
show-all-tabs-cmd =
    .accesskey = A
    .label = Show All Tabs
bidi-switch-page-direction-item =
    .label = Switch Page Direction
    .accesskey = D

## History menu

history-menu =
    .label = History
    .accesskey = s
show-all-history-cmd2 =
    .label = Show All History
clear-recent-history =
    .label = Clear Recent History…
sync-tabs-menu3 =
    .label = Synced Tabs
history-restore-last-session =
    .label = Restore Previous Session
hidden-tabs =
    .label = Hidden Tabs
history-undo-menu =
    .label = Recently Closed Tabs
history-undo-window-menu =
    .label = Recently Closed Windows

## Bookmarks menu

bookmarks-menu =
    .label = Bookmarks
    .accesskey = B
show-all-bookmarks2 =
    .label = Show All Bookmarks
add-cur-pages-cmd =
    .label = Bookmark All Tabs…
personalbar-cmd =
    .label = Bookmarks Toolbar
other-bookmarks-cmd =
    .label = Other Bookmarks
mobile-bookmarks-cmd =
    .label = Mobile Bookmarks

## Tools menu

tools-menu =
    .label = Tools
    .accesskey = T
downloads =
    .label = Downloads
    .accesskey = D
addons =
    .label = Add-ons
    .accesskey = A
sync-sign-in =
    .label = Sign In To { -sync-brand-short-name }…
    .accesskey = Y
sync-sync-now-item =
    .label = Sync Now
    .accesskey = S
sync-re-auth-item =
    .label = Reconnect to { -sync-brand-short-name }…
    .accesskey = R
web-developer-menu =
    .label = Web Developer
    .accesskey = W
page-source-cmd =
    .label = Page Source
    .accesskey = o
page-info-cmd =
    .accesskey = I
    .label = Page Info
preferences-cmd2 =
    .label = Options
    .accesskey = O
preferences-ldb-cmd =
    .label = Layout Debugger
    .accesskey = L
preferences-cmd-mac =
    .label = Preferences…
services-menu-mac =
    .label = Services
hide-this-app-cmd-mac2 =
    .label = Hide { -brand-shorter-name }
hide-other-apps-cmd-mac =
    .label = Hide Others
show-all-apps-cmd-mac =
    .label = Show All
window-menu =
    .label = Window
bring-all-to-front =
    .label = Bring All to Front
help-menu =
    .label = Help
    .accesskey = H
product-help2 =
    .label = { -brand-shorter-name } Help
    .accesskey = H
help-show-tour2 =
    .label = { -brand-shorter-name } Tour
    .accesskey = o
help-keyboard-shortcuts =
    .label = Keyboard Shortcuts
    .accesskey = K
help-troubleshooting-info =
    .accesskey = T
    .label = Troubleshooting Information
help-feedback-page =
    .accesskey = S
    .label = Submit Feedback…
help-safe-mode =
    .accesskey = R
    .label = Restart with Add-ons Disabled…
    .stopaccesskey = R
    .stoplabel = Restart with Add-ons Enabled
report-deceptive-site-menu =
    .label = Report Deceptive Site…
    .accesskey = D
safeb =
    .label = This isn’t a deceptive site…
    .accesskey = d
about-product2 =
    .accesskey = A
    .label = About { -brand-shorter-name }

# browser/locales/en-US/browser/toolbar.ftl

urlbar-textbox =
    .placeholder = Search or enter address
    .accesskey = d


## Toolbar items

view-bookmarks-broadcaster =
    .label = Bookmarks
view-bookmarks-key =
    .key = b
view-bookmarks-key-win =
    .key = i

view-history-broadcaster =
    .label = History
view-history-key =
    .key = h
view-tabs-broadcaster =
    .label = Synced Tabs


# browser/branding/official/locales/en-US/brand.ftl

-brand-shorter-name    = Firefox
-brand-short-name      = Firefox
-brand-full-name       = Mozilla Firefox
-vendor-short-name     = Mozilla

trademark-info        = 
    Firefox and the Firefox logos are trademarks of the Mozilla Foundation.

-sync-brand-short-name = Sync
